#!/bin/bash

function logger() {
    echo "[`date`]$* "|tee -a 
}


if [ -e out.key ]; then
	logger "out.key file already exists, this program will generate a new out.key, please move your current out.key to a new location and rerun this program"
	exit 1
fi

logger "Generate user private key file out.key"
gmssl ecparam -name sm2p256v1 -genkey -out out.key
if [ $? -ne 0 ];then
	logger "Generate User private key file out.key fail, please check"
	exit 1
fi

logger "Generate user private key file out.key success"


logger "Generate csr file out.csr"
gmssl req -batch -config gmssl_user.cnf -key out.key -new -sm3 -out out.csr
if [ $? -ne 0 ];then
	logger "Generate crs file out.csr fail, please check"
	exit 1
fi
logger "Generate csr file out.csr success"


logger "Convert out.key to pkcs#8 format file out_sk which can be used in Fabric's sdk"
gmssl pkcs8 -topk8 -in out.key -nocrypt -out out_sk
if [ $? -ne 0 ];then
	logger "Convert out.key to pkcs#8 format file out_sk fail, please check"
	exit 1
fi
logger "Convert out.key to pkcs#8 format file out_sk which can be used in Fabric's sdk success"
